<?php
/*
 * @version $Id: HEADER 1 2010-03-03 21:49 Tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin manufacturersimports v1.3.0 - GLPI 0.78
// ----------------------------------------------------------------------
 */

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

class PluginManufacturersimportsPostImport extends CommonDBTM {

   /**
   * Fonction to select the search field on the website of the supplier
   *
   * @param $suppliername the suppliername
   * @return $field for date and warranty searching
   *
   */
   function selectSupplierField ($suppliername) {

      $field='';
      if ($suppliername=="Dell") {//dell
        $field = "Ship Date:";
      } else if ($suppliername=="HP") {//hp
        $field = "Start Date";
      } else if ($suppliername=="Fujitsu-Siemens") {//fujitsu-siemens
        $field = "Service Start Date";
      } else if ($suppliername=="IBM") {//ibm
        $field = "In warranty";
      } else if ($suppliername=="Toshiba") {//toshiba
        $field = "POP Date:";
      }

      return $field;
   }

   function importDate($suppliername,$finduhtml,$contents,$warranty) {

      if ($suppliername=="Dell") {//dell
         $maDate = substr($finduhtml,49,10);
         $maDate = str_replace('/','-',$maDate);
         $maDate = str_replace('<','',$maDate);
         list($mois,$jour,$annee) = explode('-',$maDate);
         $maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));

      } else if ($suppliername=="HP") {//hp

         $maDate = substr($finduhtml,145,20);
         $maDate =trim($maDate);
         $maDate = str_replace(' ','-',$maDate);
         $maDate = str_replace('Jan','01',$maDate);
         $maDate = str_replace('Feb','02',$maDate);
         $maDate = str_replace('Mar','03',$maDate);
         $maDate = str_replace('Apr','04',$maDate);
         $maDate = str_replace('May','05',$maDate);
         $maDate = str_replace('Jun','06',$maDate);
         $maDate = str_replace('Jul','07',$maDate);
         $maDate = str_replace('Aug','08',$maDate);
         $maDate = str_replace('Sep','09',$maDate);
         $maDate = str_replace('Oct','10',$maDate);
         $maDate = str_replace('Nov','11',$maDate);
         $maDate = str_replace('Dec','12',$maDate);
         list($jour,$mois,$annee) = explode('-',$maDate);
         $maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));

      } else if ($suppliername=="Fujitsu-Siemens") {//Fujitsu : 08/09/2001

         $maDate = substr($finduhtml,60,10);
         $maDate = str_replace('/','-',$maDate);
         list($jour,$mois,$annee) = explode('-',$maDate);
         $maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));

      } else if ($suppliername=="IBM") {//IBM : 2008-09-03

         $maDate = substr($finduhtml,98,20);
         $maDate =trim($maDate);

      } else if ($suppliername=="Toshiba") {//toshiba : 6/29/04

         $maDate = substr($finduhtml,48,10);
         $maDate = str_replace('/','-',$maDate);
         $maDate = str_replace('<','',$maDate);
         list($mois,$jour,$annee) = explode('-',$maDate);
         $maDate = date("Y-m-d",mktime(0,0,0,$mois,$jour,$annee));
      }
      return $maDate;
   }

   function importWarranty($suppliername,$maDate,$contents,$warranty) {

      if ($suppliername=="Dell" && $warranty == 0) {//dell
         //
         // C. Pierron, TCS
         // Recherche automatique de la date de fin de garantie
         // (si la duree de garantie a ete parametree a zero dans
         //  l'interface utilisateur)
         $masque='([0-9]{1,2}/[0-9]{1,2}/[0-9]{4})';

         preg_match_all ($masque, $contents, $liste_resultat);
         $maDateFin = $maDate;

         foreach ($liste_resultat[0] as $occurence) {
            $maCandidate = str_replace ('/', '-', $occurence);
            list ($mois, $jour, $annee) = explode ('-', $maCandidate);
            $maCandidate = $annee."-".$mois."-".$jour;

            if ( $maCandidate > $maDateFin )
               $maDateFin = $maCandidate;
         }

         $maDateFin = date ("Y-m-d", strtotime ($maDateFin) + 86400);

         list ($adebut, $mdebut, $jdebut) = explode ('-', $maDate);
         list ($afin, $mfin, $jfin) = explode ('-', $maDateFin);

         $maGarantie = ($afin * 12 + $mfin) - ($adebut * 12 + $mdebut);
         $warranty = $maGarantie;

      } else if ($suppliername=="HP" && $warranty == 0) {//hp

         $field_fin = "End Date";
         $searchfin = stristr($contents, $field_fin);
         $maDateFin = substr($searchfin,142,20);

         $maDateFin =trim($maDateFin);
         $maDateFin = str_replace(' ','-',$maDateFin);
         $maDateFin = str_replace('Jan','01',$maDateFin);
         $maDateFin = str_replace('Feb','02',$maDateFin);
         $maDateFin = str_replace('Mar','03',$maDateFin);
         $maDateFin = str_replace('Apr','04',$maDateFin);
         $maDateFin = str_replace('May','05',$maDateFin);
         $maDateFin = str_replace('Jun','06',$maDateFin);
         $maDateFin = str_replace('Jul','07',$maDateFin);
         $maDateFin = str_replace('Aug','08',$maDateFin);
         $maDateFin = str_replace('Sep','09',$maDateFin);
         $maDateFin = str_replace('Oct','10',$maDateFin);
         $maDateFin = str_replace('Nov','11',$maDateFin);
         $maDateFin = str_replace('Dec','12',$maDateFin);

         list($jour,$mois,$annee) = explode('-',$maDateFin);
         $maDateFin = $annee."-".$mois."-".$jour;

         $maDateFin = date ("Y-m-d", strtotime ($maDateFin) + 86400);

         list ($adebut, $mdebut, $jdebut) = explode ('-', $maDate);
         list ($afin, $mfin, $jfin) = explode ('-', $maDateFin);

         $maGarantie = ($afin * 12 + $mfin) - ($adebut * 12 + $mdebut);

         $warranty = $maGarantie;
      }
    return $warranty;
  }
  
   /**
   * Prints display post import
   *
   * @param $type the type of device
   * @param $ID the ID of device
   * @param $fromsupplier selection on pre import
   * @param $fromwarranty selection on pre import
   * @param $configID ID of supplier plugin config
   * @return results of data import
   *
   */
   function seePostImport ($type,$ID,$fromsupplier,$fromwarranty,$configID) {
      global $LANG,$DB,$CFG_GLPI;

      $PluginManufacturersimportsConfig= new PluginManufacturersimportsConfig();
      $PluginManufacturersimportsConfig->GetFromDB($configID);
      $manufacturerId=$PluginManufacturersimportsConfig->fields["manufacturers_id"];

      if ($fromsupplier)
         $supplierId=$fromsupplier;
      else
         $supplierId=$PluginManufacturersimportsConfig->fields["suppliers_id"];

      $suppliername=$PluginManufacturersimportsConfig->fields["name"];
      $supplierUrl=$PluginManufacturersimportsConfig->fields["supplier_url"];
      $adddoc=$PluginManufacturersimportsConfig->fields["document_adding"];
      $rubrique=$PluginManufacturersimportsConfig->fields["documentcategories_id"];
      $addcomments=$PluginManufacturersimportsConfig->fields["comment_adding"];
      if ($fromwarranty)
         $warranty=$fromwarranty;
      else
         $warranty=$PluginManufacturersimportsConfig->fields["warranty_duration"];
      
      $itemtable=getTableForItemType($type);
      
      $query = "SELECT `".$itemtable."`.`id`,`".$itemtable."`.`name`,`".$itemtable."`.`entities_id`, `".$itemtable."`.`serial`
          FROM `".$itemtable."`, `glpi_manufacturers`
          WHERE `".$itemtable."`.`manufacturers_id` = `glpi_manufacturers`.`id`
          AND `".$itemtable."`.`is_deleted` = '0'
          AND `".$itemtable."`.`is_template` = '0'
          AND `glpi_manufacturers`.`id` = '".$manufacturerId."'
          AND `".$itemtable."`.`serial` != ''
          AND `".$itemtable."`.`id` = '".$ID."' ";
      $query.= " ORDER BY `".$itemtable."`.`name`";

      $result = $DB->query($query);


      while($line=$DB->fetch_array($result)) {

         $compSerial = $line['serial'];
         $compId = $line['id'];
         echo "<tr class='tab_bg_1' ><td>";
         $link=getItemTypeFormURL($type);
         echo "<a href='".$link."?id=".$compId."'>".$line["name"]."</a></td>";

         //On complete l url du support du fournisseur avec le modele si besoin
         $PluginManufacturersimportsModel= new PluginManufacturersimportsModel();
         $otherSerial=$PluginManufacturersimportsModel->checkIfModelNeeds($type,$compId);
         $PluginManufacturersimportsPreImport= new PluginManufacturersimportsPreImport();
         $url=$PluginManufacturersimportsPreImport->selectSupplier($suppliername,$supplierUrl,$compSerial,$otherSerial);

         //On complete l url du support du fournisseur avec le serial
         echo "<td>".$compSerial."</td>";
         if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
            echo "<td>".$otherSerial."</td>";

         echo "<td><a href='".$url."' target='_blank'>".$LANG['plugin_manufacturersimports']['import'][6]."</a></td>";
         $contents = "";

         $msgerr="";

         if ($suppliername=="Toshiba") {
            if (empty($CFG_GLPI["proxy_name"])) {

               if ($fp = fopen($url,'rb')) {
                  while (!feof($fp)) {
                     $contents .= fread($fp, 8192);
                  }
                  fclose($fp);
               } else {
                  $msgerr = $LANG['plugin_manufacturersimports']['import'][25];
               }

            } else { // Connection using proxy

               $proxy_fp = fsockopen($CFG_GLPI["proxy_name"], $CFG_GLPI["proxy_port"], $errno, $errstr, 1);
               if ($proxy_fp) {
                  fputs($proxy_fp, "GET $url\n HTTP/1.0\r\nHost: ".$CFG_GLPI["proxy_name"]."\r\n");
                  if (!empty($CFG_GLPI["proxy_user"])) {
                     fputs($proxy_fp, "Proxy-Authorization: Basic " . base64_encode ($CFG_GLPI["proxy_user"].":".$CFG_GLPI["proxy_password"]) . "\r\n");    // added
                  }
                  fputs($proxy_fp,"\r\n");
                  while(!feof($proxy_fp)) {
                     $contents.= fread($proxy_fp, 8192);
                  }
                  fclose($proxy_fp);
               } else {
                  $msgerr = $LANG['setup'][311];
               }
            }
         } else {
            $contents = getURLContent($url, $msgerr);
         }
         // On extrait la date de livraison de la variable contents.
         // Methode peu academique, mais qui fonctionne qui suppose que la page du support du fournisseur ne change pas dans le temps.
         $field=$this->selectSupplierfield ($suppliername);

         if (!stristr($contents, $field) === FALSE) {
            $finduhtml = stristr($contents, $field);

            $maDate = $this->importDate($suppliername,$finduhtml,$contents,$warranty);

            $warranty = $this->importWarranty($suppliername,$maDate,$contents,$warranty);

            //warranty for life
            if ($warranty < -120)
               $warranty=-1;

            //add new infocoms
            $ic= new infocom();
            if ($ic->getfromDBforDevice($type,$ID)) {
               //valeurs d'origine
               $buy_date=convdate($ic->fields["buy_date"]);
               $warranty_duration=$ic->fields["warranty_duration"];
               $suppliers_id=Dropdown::getDropdownName("glpi_suppliers",$ic->fields["suppliers_id"]);
               $ic_comment=$ic->fields["comment"];

               //nouvelles valeurs
               
               $date=date("Y-m-d");
               $input_infocom=array();
               
               $input_infocom["id"]=$ic->fields["id"];
               if ($supplierId!=0)
                  $input_infocom["suppliers_id"]=$supplierId;
               $input_infocom["buy_date"]=$maDate;
               $input_infocom["warranty_duration"]=$warranty;
               $input_infocom["items_id"]=$compId;
               $input_infocom["itemtype"]=$type;
               if ($addcomments)
                  $input_infocom["comment"]=$ic_comment."\n".$LANG['plugin_manufacturersimports']['import'][28]." ".$suppliername." ".$LANG['plugin_manufacturersimports']['import'][29]." (".convdate($date).")";

               $infocom = new infocom;
               $infocom->update($input_infocom);

            } else {

               //valeurs d'origine
               $buy_date="";
               $warranty_duration="";
               $suppliers_id="";
               $ic_comments="";
               //nouvelles valeurs
               $date=date("Y-m-d");
               $input_infocom=array();
               if ($supplierId!=0)
                  $input_infocom["suppliers_id"]=$supplierId;
               $input_infocom["items_id"]=$compId;
               $input_infocom["itemtype"]=$type;
               $input_infocom["buy_date"]=$maDate;
               $input_infocom["warranty_duration"]=$warranty;
               if ($addcomments)
                  $input_infocom["comment"]=$LANG['plugin_manufacturersimports']['import'][28]." ".$suppliername." ".$LANG['plugin_manufacturersimports']['import'][29]." (".convdate($date).")";

               $infocom = new infocom;
               $infocom->add($input_infocom);

            }

            $date=date("Y-m-d");
            //post message
            echo "<td><span class='plugin_manufacturersimports_import_OK'>".$LANG['plugin_manufacturersimports']['import'][13]." (".convdate($date).")</span></td>";
            echo "<td>";
            echo $LANG['financial'][26]." : ".$suppliers_id."->".Dropdown::getDropdownName("glpi_suppliers",$supplierId)."<br>";
            echo $LANG['financial'][14]." : ".$buy_date."->".convdate($maDate)."<br>";
            if ($warranty_duration==-1)
               $warranty_duration=$LANG['financial'][2];
            if ($warranty==-1)
               $warranty=$LANG['financial'][2];
            echo $LANG['financial'][15]." : ".$warranty_duration."->".$warranty."<br>";
            echo "</td>";

            // on cree un doc dans GLPI qu'on va lier au materiel

            if ($adddoc!=0) {
            //configure adding doc
          
               $time_file=date("Y-m-d-H-i");
               if ($type=='Computer') $name="computer";
               else if ($type=='NetworkEquipment') $name="networking";
               else if ($type=='Peripheral') $name="peripheral";
               else if ($type=='Monitor') $name="monitor";
               else if ($type=='Printer') $name="printer";
               else if ($type=='PluginRacksRack') $name="rack";
               $filename="infocoms_".$suppliername."_".$name."_".$compId.".html";

               //on enregistre
               $path = GLPI_DOC_DIR."/_uploads/";
               $filepath=$path.$filename;
               $fhtm=fopen($filepath,'wb');
               fwrite($fhtm,$contents);
               fclose($fhtm);

               $doc = new document;

               $input=array();
               $input["entities_id"]=$line["entities_id"];
               $input["name"]=addslashes("infocoms_".$suppliername."_".$name."_".$compId);
               $input["upload_file"]=$filename;
               $input["documentcategories_id"]=$rubrique;
               $input["mime"]="text/html";
               $input["date_mod"]=date("Y-m-d H:i:s");
               $input["users_id"]=getLoginUserID();
          
               $newdoc=$doc->add($input);
               $docitem=new Document_Item();
               $docitem->add(array('documents_id' => $newdoc,
                'itemtype' => $type,
                'items_id' => $compId));

               $query_manufacturersimports="DELETE
                    FROM `glpi_plugin_manufacturersimports_logs`
                    WHERE `items_id` = '".$compId."'
                    AND `itemtype` = '".$type."';";
               $result_manufacturersimports=$DB->query($query_manufacturersimports);

               $values["documents_id"]=$newdoc;

            }

            //insert base locale
            $date=date("Y-m-d");
            $values["import_status"]=1;
            $values["items_id"]=$compId;
            $values["itemtype"]=$type;
            $values["date_import"]=$date;
            $PluginManufacturersimportsLog = new PluginManufacturersimportsLog;
            $PluginManufacturersimportsLog->add($values);

            $_SESSION["glpi_plugin_manufacturersimports_total"]+=1;

         } else { // Failed
            $date=date("Y-m-d");
            echo "<td><span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][15]." (".convdate($date).")</span></td>";
            $query_manufacturersimports="DELETE
                  FROM `glpi_plugin_manufacturersimports_logs`
                  WHERE `items_id` = '".$compId."'
                  AND `itemtype` = '".$type."';";
            $result_manufacturersimports=$DB->query($query_manufacturersimports);

            //insert base locale
            $values["import_status"]=2;
            $values["items_id"]=$compId;
            $values["itemtype"]=$type;
            $values["date_import"]=$date;
            $PluginManufacturersimportsLog = new PluginManufacturersimportsLog;
            $PluginManufacturersimportsLog->add($values);

            if (!empty($content)) $msgerr=$LANG['plugin_manufacturersimports']['import'][25];
            echo "<td>$msgerr</td>";
         }

         echo "</tr>\n";
      }
   }
}

?>